/*
    File:               TestLibSources1.cpp
    Description:        This tool does several tests of the ArgonLibrary.
                        See DoTest() function.

    Author:             Roman Komary
    created on:         25.08.2005
    last updated:       11.11.2006 (Roman Komary)

    Copyright (c) 2005-2006, Roman Komary.

    The TestLibSources1 project is distributed under the Boost Software License, Version 1.0. (See
    accompanying file LICENSE_1_0.txt or copy at
    http://www.boost.org/LICENSE_1_0.txt)
*/

#include "stdafx.h"
#include "TestLibSources1.h"

#if defined(__STDC_SECURE_LIB__) || defined(__STDC_LIB_EXT1__)
#pragma warning( disable: 4996 )    // warning C4996: 'vsprintf' was declared deprecated
#endif

#define my_String   String
//#define my_String   _ministring_
// Note: #my_String# is used just in here for testing either
//  a #String# or a #_ministring_# string by just simply swapping
//  the define.




HINSTANCE           g_hInstance = NULL;
HWND                g_hwndApp = NULL;
HFONT               g_hFont = NULL;
ControlGrouping     g_cg;
WindowDeferrer      g_WindowDeferrer;                   // for automatic DeferWindowPos calls.
Trayicon            g_trayicon;
#define WM__TRAYICON        (WM_APP + 10)

LRESULT CALLBACK    WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK    ExtraDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                       HINSTANCE hPrevInstance,
                       LPTSTR    lpCmdLine,
                       int       nCmdShow)
{
    g_hInstance = hInstance;

    InitCommonControls();

    DialogBox( hInstance, (LPCTSTR)IDD_THEAPP, NULL, (DLGPROC)WndProc );

    return 0;
}



//miniString<TCHAR> g_testString;
//String g_testString;
//_ministring_ g_testString;
my_String g_testString;

void SetStatus( PCTSTR text )
{
    SetDlgItemText( g_hwndApp, IDC_STATUS, text ? text : _T("") );
}

/*
void Write( PCTSTR pstrFormat, ... )
{
    va_list args;
    va_start( args, pstrFormat );

    String s;
    s.Vsprintf( pstrFormat, args );

    g_testString += s;

    va_end( args );
}
*/

void WriteExact( PCTSTR pstr )
{
    g_testString += pstr;
}

void WriteLn( PCTSTR pstrFormat, ... )
{
    va_list args;
    va_start( args, pstrFormat );

    String s;
    s.Vsprintf( pstrFormat, args );
    s += _T("\r\n");

    g_testString += s;

    va_end( args );
}

VOID WriteTextA( PCSTR pstrText )
{
    g_testString += pstrText;
}

VOID WriteTextW( PCWSTR pstrText )
{
    g_testString += pstrText;
}

VOID WriteText( PCTSTR pstrText )
{
  #ifdef _UNICODE
    WriteTextW( pstrText );
  #else
    WriteTextA( pstrText );
  #endif
}

VOID WriteTextLineA( PCSTR pstrText = "" )
{
    WriteTextA( pstrText );
    WriteTextA( "\r\n" );
}

VOID WriteTextLineW( PCWSTR pstrText = L"" )
{
    WriteTextW( pstrText );
    WriteTextW( L"\r\n" );
}

VOID WriteTextLine( PCTSTR pstrText = _T("") )
{
  #ifdef _UNICODE
    WriteTextLineW( pstrText );
  #else
    WriteTextLineA( pstrText );
  #endif
}

VOID WriteA( PCSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    CHAR str[8192];
    vsprintf( str, pstrFormat, v );

    WriteTextA( str );

    va_end( v );
}

VOID WriteW( PCWSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    WCHAR str[8192];
    vswprintf( str, pstrFormat, v );

    WriteTextW( str );

    va_end( v );
}

VOID Write( PCTSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    TCHAR str[8192];
    _vstprintf( str, pstrFormat, v );

    WriteText( str );

    va_end( v );
}

VOID WriteLineA( PCSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    CHAR str[8192];
    vsprintf( str, pstrFormat, v );

    WriteTextLineA( str );

    va_end( v );
}

VOID WriteLineW( PCWSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    WCHAR str[8192];
    vswprintf( str, pstrFormat, v );

    WriteTextLineW( str );

    va_end( v );
}

VOID WriteLine( PCTSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    TCHAR str[8192];
    _vstprintf( str, pstrFormat, v );

    WriteTextLine( str );

    va_end( v );
}

VOID WriteHorzLine()
{
    WriteText( _T("===================================================================\r\n") );
}

VOID WriteChapterA( PCSTR pstrTitle )
{
    if( !g_testString.IsEmpty() )
        WriteTextA( "\r\n\r\n" );
    WriteHorzLine();
    //WriteTextA( "    " );
    WriteTextA( pstrTitle );
    WriteTextA( "\r\n\r\n" );
}

VOID WriteChapterW( PCWSTR pstrTitle )
{
    if( !g_testString.IsEmpty() )
        WriteTextW( L"\r\n\r\n" );
    WriteHorzLine();
    //WriteTextW( L"    " );
    WriteTextW( pstrTitle );
    WriteTextW( L"\r\n\r\n" );
}

VOID WriteChapter( PCTSTR pstrTitle )
{
  #ifdef _UNICODE
    WriteChapterW( pstrTitle );
  #else
    WriteChapterA( pstrTitle );
  #endif
}

VOID WriteTitleA( PCSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    CHAR str[8192];
    strcpy( str, "\r\n____ " );
    vsprintf( str + strlen(str), pstrFormat, v );
    strcat( str, " _____________\r\n" );

    WriteTextA( str );

    va_end( v );
}

VOID WriteTitleW( PCWSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    WCHAR str[8192];
    wcscpy( str, L"\r\n____ " );
    vswprintf( str + wcslen(str), pstrFormat, v );
    wcscat( str, L" _____________\r\n" );

    WriteTextW( str );

    va_end( v );
}

VOID WriteTitle( PCTSTR pstrFormat, ... )
{
    va_list v;
    va_start( v, pstrFormat );

    TCHAR str[8192];
    _tcscpy( str, _T("\r\n____ ") );
    _vstprintf( str + _tcslen(str), pstrFormat, v );
    _tcscat( str, _T(" _____________\r\n") );

    WriteText( str );

    va_end( v );
}

INT MakeVisibleChar( INT ch )
{
    return ch >= ' ' ? ch : '';
}

VOID WriteBuffer( CONST BYTE *pBuffer, INT cBuffer, INT nBytesPerRow = 8 )
{
    TCHAR str[0x10000] = _T(""), s[256];
    INT i, idx = 0, irow = 0;
    INT update_every_n_rows = (sizeof(str) / sizeof(*str)) / 100;

    while( idx < cBuffer )
    {
        _stprintf( s, _T("    %08lX:  "), (UINT_PTR)(pBuffer + idx) );
        _tcscat( str, s );

        INT idx2 = idx;

        for( i = 0 ; i < nBytesPerRow ; ++i ) {
            if( idx < cBuffer )
                _stprintf( s, _T("%02X "), (UINT)pBuffer[idx] );
            else
                _tcscpy( s, _T("   ") );
            ++idx;
            _tcscat( str, s );
        }

        _tcscat( str, _T(" ") );

        idx = idx2;

        for( i = 0 ; i < nBytesPerRow ; ++i ) {
            if( idx < cBuffer )
                _stprintf( s, _T("%c"), (UINT)MakeVisibleChar( pBuffer[idx] ) );
            else
                break;
            ++idx;
            _tcscat( str, s );
        }

        _tcscat( str, _T("\r\n") );

        if( (irow % update_every_n_rows) == update_every_n_rows - 1 ) {
            WriteText( str );
            str[0] = 0;
        }

        ++irow;
    }

    WriteText( str );
}

VOID WriteDynMem( const DynMem& dm, PCTSTR pstrMisc )
{
    static TCHAR empty = _T('.');
    TCHAR str[16384];
    DimSize currsize = dm.GetSize();

    _tcscpy( str, _T("  (_") );
    _tcscat( str, pstrMisc );
    _tcscat( str, _T("_):\r\n") );

    _idx_ i = _strlen_( str );

    if( currsize[2] )
        for( dim_t z = 0 ; z < currsize[2] ; z++ ) {
            for( dim_t y = 0 ; y < currsize[1] ; y++ ) {
                for( dim_t x = 0 ; x < currsize[0] ; x++ ) {
                    DimPt pos(3);
                    pos[0] = (DWORD)x; pos[1] = (DWORD)y; pos[2] = (DWORD)z;
                    BitCPtr p = dm.ConstPtrAt( pos );
                    TCHAR ch = (TCHAR)p.GetChar();
                    str[i++] = ch ? ch : empty;
                }
                str[i++] = _T('\r');
                str[i++] = _T('\n');
            }
            str[i++] = _T('\r');
            str[i++] = _T('\n');
        }
    else
        for( dim_t y = 0 ; y < currsize[1] ; y++ ) {
            for( dim_t x = 0 ; x < currsize[0] ; x++ ) {
                DimPt pos(2);
                pos[0] = (DWORD)x; pos[1] = (DWORD)y;
                BitCPtr p = dm.ConstPtrAt( pos );
                TCHAR ch = (TCHAR)p.GetChar();
                str[i++] = ch ? ch : empty;
            }
            str[i++] = _T('\r');
            str[i++] = _T('\n');
        }

    _tcscpy( &str[i], _T("**** **** **** **** **** **** **** **** ****\r\n") );

    WriteText( str );
}

VOID WriteWinError( DWORD dwError )
{
    TCHAR str[512];
    FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM,
                   NULL,
                   dwError,
                   0,
                   str,
                   _countof(str),
                   NULL );
    Write( _T("LastError = %u (0x%lX), "), dwError, dwError );
    Write( str );
}

VOID WriteLastError()
{
    WriteWinError( GetLastError() );
}



class myTlsData
{
    public :
        myTlsData() { m_nr = s_nextNr++; }
        ~myTlsData() {  }

        int m_nr;
        static int s_nextNr;

        static myTlsData *get();
};

int myTlsData::s_nextNr = 0;

CritSec                 g_lock;
SingleInstanceDetection g_single( _T("testlibsources1-instance") );
tlsautoPtr<myTlsData>   g_myTlsData;

myTlsData *myTlsData::get()
{
    if( g_myTlsData ) return g_myTlsData;
    return g_myTlsData = new myTlsData();
}



// Definition of TestError:
// First that what usually would be in a header file:

enum testerror_t
{
    errTstStringIdError = 0x80000001,
};

#define GROUPID_TESTERROR           { 0x6b21493d, 0xf663, 0x41c2, { 0x8c, 0x91, 0x3f, 0xd1, 0xb0, 0xd6, 0x5a, 0xa1 } }  // {6B21493D-F663-41C2-8C91-3FD1B0D65AA1}
#define GROUPID_TESTERROR_STR       "{6B21493D-F663-41C2-8C91-3FD1B0D65AA1}"
extern const GUID g_groupidTestError;

class TestError_Def {  };
typedef ErrorGroupT<GenericErrorClass, TestError_Def> TestErrorGroup;

#define tsterr  ArgonLibrary::GenErr( &TestErrorGroup::s_Access, __FUNCTION__ )

// Now that what usually would be in a cpp file:

const GenErrDesc g_TestErrorDescs[] = {
    { errTstStringIdError,                  LANG_NEUTRAL,       gemapt_Direct,      (LONG_PTR) IDS_1ST_TEST_ERROR_STRING },
    GENERRDESC_ENDMARK
};

const GUID                                    g_groupidTestError = GROUPID_TESTERROR;
TestErrorGroup                                g_egrTest( g_groupidTestError );
GenericErrorDescriptionTableT<TestErrorGroup> g_edtTest( g_TestErrorDescs );



///<summary>
///  <b>DoTest()</b> executes our test procedures by calling <code>DoTest()</code>. <br/>
///  End of summary.
///</summary>
///<remarks>
///  This is a sample. Call the following:
///  <pre>
///  DoTest();
///  </pre>
///  End of sample.
///</remarks>
void DoTest()
{
    WaitCursor wc;
    singleLock lock = g_lock;
    int i;

    SetStatus( _T("testing...") );
    g_testString.Empty();
    SetDlgItemText( g_hwndApp, IDC_EDIT1, g_testString );
    UpdateWindow( g_hwndApp );


    WriteLn( _T("g_lock is %s."), lock.IsLocked() ? _T("locked") : _T("unlocked") );

    WriteLn( _T("Are we single instance: %s."), g_single.IsSingleInstance() ? _T("yes") : _T("no") );

    WriteLn( _T("myTlsData nr = %d."), myTlsData::get()->m_nr );
    WriteLn( _T("myTlsData nr = %d."), myTlsData::get()->m_nr );

    Mutex mtx1, mtx2(true);
    multiWait wait( 2, mtx1.get(), mtx2.get() );
    waitResult ret = wait.Wait();
    WriteLn( _T("Signalled mutex index is %d. All signalled is %s."),
             ret.IndexSignalled(), ret.AllSignalled() ? _T("true") : _T("false") );
    // I don't know why it says the mtx1 is signalled although it should not be.
    // It's not a problem of the ArgonLibrary. The MFC classes I tested somewhere
    // else and they had the same result.


    {
    WriteLn( _T("iterator values: before_iteration_start = %d, end_of_iteration = %d"),
             Iterator::before_iteration_start(), Iterator::end_of_iteration() );

    #ifndef _argon_no_CString
    CString _s = _T("CString test. ");
    #else
    String _s = _T("no CString test. ");
    #endif
    my_String s1 = "ascii test. ", s2 = L"unicode test. ", s3 = _s, s4( (PCTSTR) IDS_IDSTEST ), s5( _T('o'), 5 );
    s4 += _s;
    s5 += s4.Mid( 9, 5 );

    my_String path = _T("C:\\mypath\\dummy");

    WriteLn( s1 + s2 + s3 + s4 + s5 );
    WriteLn( path | _T("../my.file") );
    WriteLn( my_String().Sprintf( _T("sprintf test: %d 0x%x {-.0;%f} {~f;%g} %c {^,<-;%s} {by +;%u}"),
                               -3, 0x123, 12.5, 24.5e13, _T('/'), _T("test-string"), 4000 ) );
    WriteLn( my_String().Sprintf( _T("sprintf test: %d 0x%x {-.0;%f} {~f;%g} %c {^,<-;%s} {by +;%u}"),
                               -3, 0x123, 12.5, 24.5e13, _T('/'), _T("test-string"), 4000 ).AccomplishSegments() );
    WriteLn( s1.Remove( _T("it") ) );
    WriteLn( s1.Insert( 3, _T('i'), 2 ).Insert( 6, _T("test-") ) );
    WriteLn( s1.RemoveSpaces() );
    WriteLn( s1.Remaini( _T("ait") ) );
    WriteLn( s1.Inflate( 1, -1 ) );
    s1 += _T("%nix.");
    WriteLn( (s1 + (PCTSTR) IDS_APP_TITLE).UnSformat() );
    s1 = _T("sterreich uert sich\nber\tDas rtchen...\tC:\\Programme\\Aktion rtchen Subern");
    s1.MakeCRLF();
    s2 = s1.StrToEsc();
    s3 = s2.EscToStr();
    WriteLn( s2 );
    WriteLn( s3 );
    WriteLn( _T("char index 2nd row = %d"), s3.GetStartcharindexOffsetRow(3, 1) );
    WriteLn( s4.Reverse() );
    WriteLn( s4.Uppercase() );
    WriteLn( s4.Lowercase() );

    TCHAR strlst[] = _T("s1\0s2\0s3\0");
    WriteLn( s1.fromStrlst( strlst ) );
    freeMalloc<TCHAR> pstrlst = s1.toStrlst();
    WriteLn( _T("pstrlst length = %d, strlen = %d"), _strlstlen_( pstrlst ), _strlen_( pstrlst ) );

    bool matched1 = path.Matchpathmasks( _T("*file*.test;*my*") );
    bool matched2 = path.Matchpathmasks( _T("*file*.test;*the*") );
    WriteLn( _T("matched 1st = %d, 2nd = %d"), matched1, matched2 );
    path.Replaceistring( _T("my"), _T("the") );
    matched2 = path.Matchpathmasks( _T("*file*.test;*the*") );
    WriteLn( _T("%s matched2 = %d"), path, matched2 );

    s1 = _T("Dies ist die erste Zeile.\nNun haben wir die 2te.\nUnd das ist die letzte.");
    s1.MakeCRLF();
    WriteLn( s1 );
    s1.Indent( 8, 4, false );
    WriteLn( s1 );
    s1.Unindent( 4, 4, false );
    WriteLn( s1 );
    WriteLn( s2.GetWindowtext(g_hwndApp) );
    WriteLn( s2.GetProgramFilesFolder() );
    WriteLn( s2.GetCurrentdirectory() );
    WriteLn( s2.GetExecutablefilename() );
    s3 = _T("testfile1234.dat");
    for( i = 0 ; i < 12 ; ++i )
        WriteLn( s3.OverwriteDecNumber((i << i) + i * i) );
    for( i = 0 ; i < 12 ; ++i )
        WriteLn( s3.OverwriteDecNumber((i << i) + i * i, StrNumT_Decimal) );
    s1 = _T("    Dies ist eine simple Zeile.");
    _idx_ idx = s1.Strstr( _T("ist") );
    WriteLn( _T("string = \"%s\""), s1 );
    WriteLn( _T("start parsing at %d (space before \"ist\"):"), --idx );
    WriteLn( _T("    \"") + s1.Findnextword( idx, -1 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  0 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  1 ) + _T('\"') );
    WriteLn( _T("start parsing at %d (start of \"ist\"):"), ++idx );
    WriteLn( _T("    \"") + s1.Findnextword( idx, -1 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  0 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  1 ) + _T('\"') );
    WriteLn( _T("start parsing at %d (inside \"ist\"):"), ++idx );
    WriteLn( _T("    \"") + s1.Findnextword( idx, -1 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  0 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  1 ) + _T('\"') );
    WriteLn( _T("start parsing at %d (last char of \"ist\"):"), ++idx );
    WriteLn( _T("    \"") + s1.Findnextword( idx, -1 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  0 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  1 ) + _T('\"') );
    WriteLn( _T("start parsing at %d (space after \"ist\"):"), ++idx );
    WriteLn( _T("    \"") + s1.Findnextword( idx, -1 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  0 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( idx,  1 ) + _T('\"') );
    WriteLn( _T("start parsing at end of string (on null terminator):") );
    WriteLn( _T("    \"") + s1.Findnextword( s1.length(), -1 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( s1.length(),  0 ) + _T('\"') );
    WriteLn( _T("    \"") + s1.Findnextword( s1.length(),  1 ) + _T('\"') );
    WriteLn( _T("GetLastError = %u"), GetLastError() );
    WriteLn( my_String().GetSystemerrorMessage( GetLastError() ) );

    Version v;
    WriteLn( _T("Tverstr_Comments\t = \"%s\""),         v.Get( Tverstr_Comments         ) );
    WriteLn( _T("Tverstr_CompanyName\t = \"%s\""),      v.Get( Tverstr_CompanyName      ) );
    WriteLn( _T("Tverstr_FileDescription\t = \"%s\""),  v.Get( Tverstr_FileDescription  ) );
    WriteLn( _T("Tverstr_FileVersion\t = \"%s\""),      v.Get( Tverstr_FileVersion      ) );
    WriteLn( _T("Tverstr_InternalName\t = \"%s\""),     v.Get( Tverstr_InternalName     ) );
    WriteLn( _T("Tverstr_LegalCopyright\t = \"%s\""),   v.Get( Tverstr_LegalCopyright   ) );
    WriteLn( _T("Tverstr_LegalTrademarks\t = \"%s\""),  v.Get( Tverstr_LegalTrademarks  ) );
    WriteLn( _T("Tverstr_OriginalFilename = \"%s\""),   v.Get( Tverstr_OriginalFilename ) );
    WriteLn( _T("Tverstr_PrivateBuild\t = \"%s\""),     v.Get( Tverstr_PrivateBuild     ) );
    WriteLn( _T("Tverstr_ProductName\t = \"%s\""),      v.Get( Tverstr_ProductName      ) );
    WriteLn( _T("Tverstr_ProductVersion\t = \"%s\""),   v.Get( Tverstr_ProductVersion   ) );
    WriteLn( _T("Tverstr_SpecialBuild\t = \"%s\""),     v.Get( Tverstr_SpecialBuild     ) );
    WriteLn( my_String(_W(Averstr_ProductVersion)) + _T(":") );
    WriteLn( _T("BuildNr = ") + my_String::fromInt(v.GetBuildNr(Tverstr_ProductVersion)) );
    my_String vernr = v.Get( Tverstr_ProductVersion );
    WriteLn( vernr );
    WriteLn( my_String(vernr).BeautifyVersionNr() );
    WriteLn( vernr.GetBuildNr() );
    WriteLn( String().Sprintf( _T("ver nr = {~ver#;%s}   build nr = {build#;%s}"), vernr, vernr ) );
    WriteLn( String().Sprintf( _T("ver nr = {~ver#;%s}   build nr = {build#;%s}"), vernr, vernr ).AccomplishSegments() );
    vernr = _T("3 0 10 2853");
    WriteLn( vernr );
    WriteLn( my_String(vernr).BeautifyVersionNr() );
    WriteLn( vernr.GetBuildNr() );
    WriteLn( String().Sprintf( _T("ver nr = {~ver#;%s}   build nr = {build#;%s}"), vernr, vernr ) );
    WriteLn( String().Sprintf( _T("ver nr = {~ver#;%s}   build nr = {build#;%s}"), vernr, vernr ).AccomplishSegments() );
    s1 = _T("string-nr1|string-nr2|string-nr3");
    WriteLn( s1.Findword( 1, findword_SeparatorChars, _T("|") ) );
    WriteLn( s1.Findword( 2, findword_SeparatorChars, _T("|") ) );
    WriteLn( s1.Findword( 3, findword_SeparatorChars, _T("|") ) );

    s1 = _T("cmdlineApp.exe -parm -parm2=\"some values \'single\' and \'\'double\'\' and \"\"string\"\"\" -parm3 = VALUE \"C:\\Program Files\\myFolder\\blabla.ini\"");
    WriteLn( s1 );
    basicSyntaxParser<String> parser( syntaxparserlanguage_Cmdline, s1 );
    idx = 0;
    for( ;; )
    {
        basicSPresult<String> result;
        idx = parser.FindNextSyntaxelm( result, idx );
        if( idx < -1 ) WriteLn( _T("**** parser error.") );
        if( idx < 0 ) break;
        WriteLn( _T("bspsyxt: %d inner: [") + parser.ExtractInnerSyntaxelm(result) + _T("]\touter: [") + parser.ExtractOuterSyntaxelm(result) + _T(']'),
                 result.m_syntaxType );
    }

    s1="test-string";
    const my_String const_s1 = s1;
    TCHAR ch1 = s1[0];
    WriteLn( _T("%s, %c, addr: 0x%08lx 0x%08lx (both addrs must be equal)"), s1, ch1, s1, &s1[0] );
    s1[0] = _T('T');
    WriteLn( _T("%s, %c, addr: 0x%08lx 0x%08lx (both addrs must be equal)"), s1, (TCHAR) s1[0], s1, &s1[0] );
    WriteLn( _T("%s, %c, addr: 0x%08lx 0x%08lx (both addrs must be equal)"), const_s1, const_s1[0], const_s1, &const_s1[0] );
    // NOTE: Above, we must use the (TCHAR) cast operator on s1[0].
    //  s1[0] will return the StringT<>::Proxy object. And if we omit the (TCHAR),
    //  then the compiler would not know to cast the Proxy to a destination
    //  type because we are in a ... sequence.
    // Note: For the const_s1[0] this is not necessary because the Proxy will
    //  be returned. Instead the StringT<>'s #const Tchar& operator[]( _idx_ idx ) const#
    //  operator will be used directly and a TCHAR& will be the result already.

    s1.Empty();
    s1 += MAKEINTRESOURCE( IDS_APP_TITLE );
    s1 += _T(", ");
    s1 += MAKEINTRESOURCE( IDS_IDSTEST );
    WriteLn( s1 );

    {
    String s;
    FileFinder ff( my_String().GetExecutabledirectory() | _T("readme*.txt") );
    WriteLn( ff.getFoundFile() );
    StdioFile f( ff.getFoundFile(), File::modeOpen | File::accessRead | File::typeText );
    f.readText( s );
    s.MakeCRLF();
    WriteLn( s );
    }

    {
    // Unicode text stream reading.
    StringW s = L"-First Line.\rNext Line.\r";
    s[0] = (WCHAR) 0xfeff;
    MemFile f( (void*) (PCWSTR) s, s.length() * sizeof(WCHAR), MemFile::memf_Reference );
    TextStream txt( f );
    String s2;
    txt.ReadToEnd( s2, TextStream::txtmdCRLF );
    WriteLn( s2 );
    }

    {
    // Ascii text stream reading.
    StringA s = "First Line.\rNext Line.\r";
    MemFile f( (void*) (PCSTR) s, s.length() * sizeof(char), MemFile::memf_Reference );
    TextStream txt( f );
    String s2;
    txt.ReadToEnd( s2, TextStream::txtmdCRLF );
    WriteLn( s2 );
    }

    {
    StringA s = "1st Line of text.\nEnd of text.\n";
    MemFile f( 1024 );
    TextStream txt( f );
    txt.m_EncodingType = TextStream::enctUnicode;
    //txt.m_ByteOrder = TextStream::byorBigEndian;
    txt.WriteA( s, s.length() );
    HexView hv( 16 );
    String s2 = hv.GetFromBuffer( 0, f.getMemoryStartPtr(), (_size_t_) f.getLength(), _T("\r\n") );
    WriteExact( s2 );
    }

    {
    FileFinder ff( my_String().GetExecutabledirectory() | _T("*.png") );
    WriteLn( ff.getFoundFile() );
    File f( ff.getFoundFile(), File::modeOpen | File::accessRead | File::typeBinary );
    UINT64 cbuf;
    freeMalloc<BYTE> ptr = f.readBinary( cbuf );
    // now we make a hex view output of the binary data
    /*
    int cremain = (int) cbuf;
    int perline = 16, i;
    PBYTE p = ptr;
    for( ;; )
    {
        if( cremain <= 0 ) break;
        my_String s;
        s.Sprintf( _T("%08xh: "), (int) cbuf - cremain );
        for( i = 0 ; i < perline ; ++i )
            if( i < cremain ) s += my_String().Sprintf( _T("%02X "), p[i] );
            else              s += _T("   ");
        s += _T("; ");
        for( i = 0 ; i < perline ; ++i )
            if( i < cremain ) s += p[i] >= ' ' ? (TCHAR) p[i] : _T('.');
            else              break;
        s.UnSformat();
        WriteLn( s );
        p       += perline;
        cremain -= perline;
    }
    */
    HexView hv( 16 );
    my_String s = hv.GetFromBuffer( 0, ptr, (_size_t_) cbuf, _T("\r\n") );
    WriteExact( s );

    // Now we copy the file into a memory file and display its contents, too.
    WriteLn( _T("copy of the file into a memory-file:") );
    f.SeekToBegin();
    MemFile memf;
    memf.CopyFromFile( &f, (_size_t_) f.getLength() );
    memf.SeekToBegin();
    ptr = memf.readBinary( cbuf );
    s = hv.GetFromBuffer( 0, ptr, (_size_t_) cbuf, _T("\r\n") );
    WriteExact( s );

    WriteLn( _T("and output the same data in a simple 1-line format to show the HexView capabilities:") );
    hv.Configure( false, true, false );
    hv.Settings( 16, 1, NULL, _T("%02X-"), _T("") );
    s = hv.GetFromBuffer( 0, ptr, (_size_t_) cbuf, NULL );
    // now we have to trim the final '-' char that comes from the "%02X-" format.
    s.TrimEnd( _T("-") );
    WriteExact( s );
    WriteLn( _T("") );
    }

    s1 = _T("Language:  ") +
         my_String().GetLocaleinfoLanguagename( GetThreadLocale() ) +
         _T("  (") +
         my_String().GetLocaleinfoEngLanguagename( GetThreadLocale() ) +
         _T(')');
    WriteLn( s1 );

    {
    Array<BYTE,1> ar1;
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar1.Ptr(), &ar1, ar1.GetSize(), ar1.GetAvailableSize() );
    ar1.SetSize( 1 );
    Array<BYTE,0> tmp1;
    tmp1.SetSize( 256 );    // just to alloc memory *after* the #ar1# memory.
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar1.Ptr(), &ar1, ar1.GetSize(), ar1.GetAvailableSize() );
    WriteLn( _T("---------------") );

    Array<BYTE,0> ar2;
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar2.Ptr(), &ar2, ar2.GetSize(), ar2.GetAvailableSize() );
    ar2.SetSize( 1 );
    Array<BYTE,0> tmp2;
    tmp2.SetSize( 256 );    // just to alloc memory *after* the #ar2# memory.
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar2.Ptr(), &ar2, ar2.GetSize(), ar2.GetAvailableSize() );
    ar2.SetSize( 1024 );
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar2.Ptr(), &ar2, ar2.GetSize(), ar2.GetAvailableSize() );
    WriteLn( _T("---------------") );

    Array<BYTE,0> ar3;
    ar3.SetBlockSize( 16 * 1024 );
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar3.Ptr(), &ar3, ar3.GetSize(), ar3.GetAvailableSize() );
    ar3.SetSize( 1 );
    Array<BYTE,0> tmp3;
    tmp3.SetSize( 256 );    // just to alloc memory *after* the #ar3# memory.
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar3.Ptr(), &ar3, ar3.GetSize(), ar3.GetAvailableSize() );
    ar3.SetSize( 1024 );
    WriteLn( _T("memptr = 0x%08lx, ar-addr = 0x%08lx, size = %d, available = %d"), ar3.Ptr(), &ar3, ar3.GetSize(), ar3.GetAvailableSize() );
    WriteLn( _T("---------------") );
    }

    WriteLn( my_String::getWeekdayFullName  ( 1 ) );
    WriteLn( my_String::getWeekdayAbbrevName( 1 ) );
    WriteLn( my_String::getMonthFullName    ( 1 ) );
    WriteLn( my_String::getMonthAbbrevName  ( 1 ) );

    TimeSpan t1 = TimeSpan::getCurrentTime();
    WriteLn( _T("Now: ") + my_String::timeFmt     (t1) );
    WriteLn( _T("Now: ") + my_String::timeFmtEx   (t1) );
    WriteLn( _T("Now: ") + my_String::timeFmtEx   (t1, t1.get_Nanos(), _T("Week %(cwn),  %#c.%(.ms)  (%(hmt))  %z")) );
    WriteLn( _T("UTC: ") + my_String::timeFmtExGmt(t1, t1.get_Nanos(), _T("Week %(cwn),  %#c.%(.ms)  (%(hmt))  %z")) );
    /*
    _tsetlocale( LC_ALL, _T("usa") );
    WriteLn( _T("Now: ") + my_String::timeFmtEx   (t1, t1.get_Nanos(), _T("Week %(cwn),  %#c.%(.ms)  (%(hmt))  %z"), (MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), SORT_DEFAULT))) );
    WriteLn( _T("UTC: ") + my_String::timeFmtExGmt(t1, t1.get_Nanos(), _T("Week %(cwn),  %#c.%(.ms)  (%(hmt))  %z"), (MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), SORT_DEFAULT))) );
    _set_default_locale_();
    */
    WriteLn( _T("Julian Day today: %ld"), t1.getJulianDay() );
    TimeSpan t2 = t1 + TimeSpan::fromSpan( 0, 1 );
    WriteLn( _T("Tomorrow: ") + my_String::timeFmt(t2, _T("%#c")) );
    TimeSpan t_1 = t1 + TimeSpan::fromSpan( 0, -1 );
    WriteLn( _T("Yesterday: ") + my_String::timeFmt(t_1, _T("%#c")) );

    WriteLn( _T("GetFractionalFromNanos(  999999999 ) = 0x%08X -> %d"), TimeSpan::GetFractionalFromNanos(999999999), TimeSpan::GetNanosFromFractional(TimeSpan::GetFractionalFromNanos(999999999)) );
    WriteLn( _T("GetFractionalFromNanos(         -1 ) = 0x%08X -> %d"), TimeSpan::GetFractionalFromNanos(-1),        TimeSpan::GetNanosFromFractional(TimeSpan::GetFractionalFromNanos(-1)       ) );
    WriteLn( _T("GetFractionalFromNanos(          0 ) = 0x%08X -> %d"), TimeSpan::GetFractionalFromNanos(0),         TimeSpan::GetNanosFromFractional(TimeSpan::GetFractionalFromNanos(0)        ) );
    WriteLn( _T("GetNanosFromFractional( 0XFFFFFFFF ) = %d"), TimeSpan::GetNanosFromFractional(0xffffffff) );
    WriteLn( _T("GetNanosFromFractional( 0X00000000 ) = %d"), TimeSpan::GetNanosFromFractional(0x00000000) );

    // Note: The following nanos to fractionals *must not* result in changed nanos!
    bool nanos_changed = false;
    WriteLn( _T("--Start with Nanos and convert to Fractionals:") );
    for( i = 0 ; i < 20 ; ++i )
    {
        DWORD dw = (DWORD) (rand() ^ (rand() << 8) ^ (rand() << 16) ^ (rand() << 24));
        int nanos = dw % 1000000000;
        int nanos_start = nanos;
        for( int j = 0 ; j < 3 ; ++j )
        {
            Write( j > 0 ? _T(" -> %09d -> ") : _T("%09d -> "), nanos );
            DWORD frac = TimeSpan::GetFractionalFromNanos( nanos );
            Write( _T("0x%08X"), frac );
            nanos = TimeSpan::GetNanosFromFractional( frac );
            if( nanos != nanos_start ) nanos_changed = true;
        }
        if( nanos != nanos_start )
            Write( _T("  **CHANGED**") );
        WriteLn( _T("") );
    }
    if( nanos_changed ) Beep( 1000, 100 );
    // Note: Since a fractional has a much finer granularity than nanos,
    // the following fractionals to nanos will often result in changed fractionals.
    WriteLn( _T("--Start with Fractionals and convert to Nanos:") );
    for( i = 0 ; i < 20 ; ++i )
    {
        DWORD dw = (DWORD) (rand() ^ (rand() << 8) ^ (rand() << 16) ^ (rand() << 24));
        DWORD frac = dw;
        DWORD frac_start = frac;
        for( int j = 0 ; j < 3 ; ++j )
        {
            Write( j > 0 ? _T(" -> 0x%08X -> ") : _T("0x%08X -> "), frac );
            int nanos = TimeSpan::GetNanosFromFractional( frac );
            Write( _T("%09d"), nanos );
            frac = TimeSpan::GetFractionalFromNanos( nanos );
            
        }
        if( frac != frac_start )
            Write( _T("  **CHANGED**") );
        WriteLn( _T("") );
    }

    WriteLn( _T("Computer Name: ") + my_String().GetComputername() );
    }


    // ==== MemorySpace and MemoryShared ============
    {
    WriteChapter( _T("classes MemorySpace and MemoryShared") );

    {
    WriteTitle( _T("MemorySpace :: Exchange") );

    MemorySpace mem1, mem2;
    mem1.SetSize( 346 );
    mem2.SetSizeAndType( 1795, MemT_FileMapping );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("exchanging ...") );
    mem1.Exchange( mem2 );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );
    }


    {
    WriteTitle( _T("MemoryShared :: Exchange") );

    //MemorySpace mem1, mem2;
    MemoryShared mem1, mem2;
    mem1.SetSize( 346 );
    mem2.SetSizeAndType( 1795, MemT_FileMapping );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("exchanging ...") );
    mem1.Exchange( mem2 );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("WritePtr ...") );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem1.WritePtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem2.WritePtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("WritePtr ...") );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem1.WritePtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem2.WritePtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );
    }


    {
    WriteTitle( _T("MemorySpace :: CopyOf") );

    MemorySpace mem1, mem2;
    mem1.SetSize( 2346 );
    mem2.SetSizeAndType( 3795, MemT_FileMapping );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("copying ...") );
    mem1.CopyFrom( mem2 );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );
    }


    {
    WriteTitle( _T("MemoryShared :: ShareFrom") );

    //MemorySpace mem1, mem2;
    MemoryShared mem1, mem2;
    mem1.SetSize( 2346 );
    mem2.SetSizeAndType( 3795, MemT_FileMapping );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("sharing ...") );
    mem1.ShareFrom( mem2 );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem1.ConstPtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               mem2.ConstPtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("WritePtr ...") );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem1.WritePtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem2.WritePtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );

    WriteLine( _T("WritePtr ...") );

    WriteLine( _T("mem1 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem1.WritePtr(), mem1.GetSize(), mem1.GetAllocatedSize(), mem1.GetMemType() );
    WriteLine( _T("mem2 ptr = 0x%08lX, size = %d, allocated = %d, mem_t = %d"),
               (PBYTE) mem2.WritePtr(), mem2.GetSize(), mem2.GetAllocatedSize(), mem2.GetMemType() );
    }


    {
    WriteTitle( _T("named MemorySpace") );

    MemorySpace mem1, mem2;
    mem1.SetSizeAndType( 64, MemT_FileMapping, _T("Named MemorySpace - Test1") );
    strcpy( (PSTR) (PBYTE) mem1.WritePtr(), "Testing named MemorySpace objects." );
    mem2.SetSizeAndType( 64, MemT_FileMapping, _T("Named MemorySpace - Test1") );
    WriteLineA( "mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    WriteLineA( "mem2 = 0x%08lX = %s", mem2.ConstPtr(), (PCSTR)mem2.ConstPtr() );
    *(PSTR) (PBYTE) mem1.WritePtr() = '#';
    WriteLineA( "mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    WriteLineA( "mem2 = 0x%08lX = %s", mem2.ConstPtr(), (PCSTR)mem2.ConstPtr() );
    }


    {
    WriteTitle( _T("Test MemorySpace data locking") );

    MemorySpace mem1, mem2, mem3;
    mem1.SetSizeAndType( 64, MemT_New );
    strcpy( (PSTR) (PBYTE) mem1.WritePtr(), "Testing MemorySpace locking." );

    WriteLine( _T("----- without data locked ----------") );
    WriteLineA( "constptr mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    if( mem1.WritePtr() ) WriteLineA( "writeptr mem1 = 0x%08lX = %s", (PBYTE) mem1.WritePtr(), (PCSTR) (PBYTE) mem1.WritePtr() );
    else                  WriteLineA( "writeptr mem1 = 0x%08lX", (PBYTE) mem1.WritePtr() );

    mem2 = mem1;
    WriteLine( _T(".and trying copying memory:") );
    WriteLineA( "constptr mem2 = 0x%08lX = %s", mem2.ConstPtr(), (PCSTR)mem2.ConstPtr() );
    if( mem2.WritePtr() ) WriteLineA( "writeptr mem2 = 0x%08lX = %s", (PBYTE) mem2.WritePtr(), (PCSTR) (PBYTE) mem2.WritePtr() );
    else                  WriteLineA( "writeptr mem2 = 0x%08lX", (PBYTE) mem2.WritePtr() );

    WriteLine( _T("----- with data locked ----------") );
    MemLockData mld( &mem1 );
    WriteLineA( "constptr mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    if( mem1.WritePtr() ) WriteLineA( "writeptr mem1 = 0x%08lX = %s", (PBYTE) mem1.WritePtr(), (PCSTR) (PBYTE) mem1.WritePtr() );
    else                  WriteLineA( "writeptr mem1 = 0x%08lX", (PBYTE) mem1.WritePtr() );

    mem3 = mem1;
    WriteLine( _T(".and trying copying memory:") );
    WriteLineA( "constptr mem3 = 0x%08lX = %s", mem3.ConstPtr(), (PCSTR)mem3.ConstPtr() );
    if( mem3.WritePtr() ) WriteLineA( "writeptr mem3 = 0x%08lX = %s", (PBYTE) mem3.WritePtr(), (PCSTR) (PBYTE) mem3.WritePtr() );
    else                  WriteLineA( "writeptr mem3 = 0x%08lX", (PBYTE) mem3.WritePtr() );

    WriteLine( _T("----- resizing with data locked ----------") );
    mem1.SetSize( 1024 );
    WriteLineA( "constptr mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    if( mem1.WritePtr() ) WriteLineA( "writeptr mem1 = 0x%08lX = %s", (PBYTE) mem1.WritePtr(), (PCSTR) (PBYTE) mem1.WritePtr() );
    else                  WriteLineA( "writeptr mem1 = 0x%08lX", (PBYTE) mem1.WritePtr() );
    }


    {
    WriteTitle( _T("Test MemoryShared data locking") );

    MemoryShared mem1, mem2, mem3;
    mem1.SetSizeAndType( 64, MemT_New );
    strcpy( (PSTR) (PBYTE) mem1.WritePtr(), "Testing MemoryShared locking." );

    WriteLine( _T("----- without data locked ----------") );
    WriteLineA( "constptr mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    if( mem1.WritePtr() ) WriteLineA( "writeptr mem1 = 0x%08lX = %s", (PBYTE) mem1.WritePtr(), (PCSTR) (PBYTE) mem1.WritePtr() );
    else                  WriteLineA( "writeptr mem1 = 0x%08lX", (PBYTE) mem1.WritePtr() );

    mem2 = mem1;
    WriteLine( _T(".and trying sharing memory:") );
    WriteLineA( "constptr mem2 = 0x%08lX = %s", mem2.ConstPtr(), (PCSTR)mem2.ConstPtr() );
    //if( mem2.WritePtr() ) WriteLineA( "writeptr mem2 = 0x%08lX = %s", (PBYTE) mem2.WritePtr(), (PCSTR) (PBYTE) mem2.WritePtr() );
    //else                  WriteLineA( "writeptr mem2 = 0x%08lX", (PBYTE) mem2.WritePtr() );

    WriteLine( _T("----- with data locked ----------") );
    MemLockData mld( &mem1 );
    WriteLineA( "constptr mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    if( mem1.WritePtr() ) WriteLineA( "writeptr mem1 = 0x%08lX = %s", (PBYTE) mem1.WritePtr(), (PCSTR) (PBYTE) mem1.WritePtr() );
    else                  WriteLineA( "writeptr mem1 = 0x%08lX", (PBYTE) mem1.WritePtr() );

    mem3 = mem1;
    WriteLine( _T(".and trying sharing memory:") );
    WriteLineA( "constptr mem3 = 0x%08lX = %s", mem3.ConstPtr(), (PCSTR)mem3.ConstPtr() );
    if( mem3.WritePtr() ) WriteLineA( "writeptr mem3 = 0x%08lX = %s", (PBYTE) mem3.WritePtr(), (PCSTR) (PBYTE) mem3.WritePtr() );
    else                  WriteLineA( "writeptr mem3 = 0x%08lX", (PBYTE) mem3.WritePtr() );

    WriteLine( _T("----- resizing with data locked ----------") );
    mem1.SetSize( 1024 );
    WriteLineA( "constptr mem1 = 0x%08lX = %s", mem1.ConstPtr(), (PCSTR)mem1.ConstPtr() );
    if( mem1.WritePtr() ) WriteLineA( "writeptr mem1 = 0x%08lX = %s", (PBYTE) mem1.WritePtr(), (PCSTR) (PBYTE) mem1.WritePtr() );
    else                  WriteLineA( "writeptr mem1 = 0x%08lX", (PBYTE) mem1.WritePtr() );
    }
    }


    // ==== DynMem ================
    {
    WriteChapter( _T("DynMem") );

    dim_t asize[]={ 3,3,3 };
    dim_t asize2[]={ 20,1,2 };
    dim_t asize3[]={ 2,2 };
    DimSize size( asize, _countof(asize) );

    DynMem dm;
    if( !dm.SetMemUnitSize(9) ) MessageBox(g_hwndApp, _T("Error SetMemUnitSize"), _T("Error"), MB_OK);
    if( !dm.SetAlignment(77) ) MessageBox(g_hwndApp, _T("Error SetAlignment"), _T("Error"), MB_OK);
    dm.SetSize(size);

    DimPt pt;
    BitPtr p1 = dm.WritePtrAt(pt);
    pt.Add(1);
    pt.Add(0);
    BitPtr p2 = dm.WritePtrAt(pt);



    DimSize currsize;
    currsize = dm.GetSize();

    {
    CHAR ch='A';
    for(int z=0;z<(int)currsize[2];z++)
        for(int y=0;y<(int)currsize[1];y++)
            for(int x=0;x<(int)currsize[0];x++) {
                DimPt pos(3);
                pos[0]=(DWORD)x; pos[1]=(DWORD)y; pos[2]=(DWORD)z;
                BitPtr p = dm.WritePtrAt(pos);
                p.SetChar(ch++);
            }
    }

    WriteDynMem(dm,_T("1"));

    dm.Add(2,3);

    WriteDynMem(dm,_T("2"));

    DimPt msrce(dm.GetDimension());
    DimPt mdest(dm.GetDimension());
    DimSize msize(dm.GetDimension());
    mdest[0] = mdest[1] = mdest[2] = 1;
    msize[0] = msize[1] = msize[2] = 3;
    dm.Move(mdest,msrce,msize,TRUE);

    WriteDynMem(dm,_T("3"));
    dm.SetHeaderSize(13);
    WriteDynMem(dm,_T("4"));

    dm.SetSize( DimSize( asize2, _countof(asize2) ) );

    WriteDynMem(dm,_T("5"));
    dm.SetHeaderSize(0);
    WriteDynMem(dm,_T("6"));

    dm.SetSize( DimSize( asize3, _countof(asize3) ) );

    WriteDynMem(dm,_T("7"));
    dm.SetHeaderSize(111);
    WriteDynMem(dm,_T("8"));



    BitCounter bc(40);
    bc--;
    int b=bc[0];
    b=bc[1];
    b=bc[39];
    b=bc[40];
    bc++;



    dim_t apos_insert[]={ 1,2,1 };
    dim_t asize_insert[]={ 5,4,2 }; // one or more (but not all) may be zero
    DimPt pos_insert( apos_insert, _countof(apos_insert) );
    DimSize size_insert( asize_insert, _countof(asize_insert) );

    dm.SetSize(size);

    currsize = dm.GetSize();

    {
    CHAR ch='A';
    for(int z=0;z<(int)currsize[2];z++)
        for(int y=0;y<(int)currsize[1];y++)
            for(int x=0;x<(int)currsize[0];x++) {
                DimPt pos(3);
                pos[0]=(DWORD)x; pos[1]=(DWORD)y; pos[2]=(DWORD)z;
                BitPtr p = dm.WritePtrAt(pos);
                p.SetChar(ch++);
            }
    }

    WriteDynMem(dm,_T("9"));

    if( !dm.Insert( pos_insert, size_insert ) ) MessageBox(g_hwndApp, _T("Error dm.Insert()"), _T("Error"), MB_OK);

    WriteDynMem(dm,_T("10"));

    if( !dm.Remove( pos_insert, size_insert ) ) MessageBox(g_hwndApp, _T("Error dm.Remove()"), _T("Error"), MB_OK);

    WriteDynMem(dm,_T("11"));

    DynMem dm2(dm);

    WriteDynMem(dm2,_T("12"));

    DynMem dm3 = dm2; // also uses copy constructor

    WriteDynMem(dm3,_T("13"));

    DynMem dm4;
    dm4 = dm3; // uses assign operator

    WriteDynMem(dm4,_T("14"));
    }


    {
    WriteChapter( _T("Test Error Codes:") );
    reterr_t tmp = interr (errOk) (_T("Some additional text.\nJust for testing purposes.")) (interr (errEOF)) (interr (errFailed)) (hreserr (E_FAIL)) (tsterr (errTstStringIdError) (_T("*IDSTRING*"))) (interr (errEeEmptyExpression));
    reterr_t err = interr (errAccessLocked) (interr (errCritical)) (hreserr (E_ABORT)) (hreserr (E_NOTIMPL)) (syserr (ERROR_INVALID_PARAMETER)) (syserr (ERROR_INVALID_PASSWORD)) (tmp);
    tmp.DisplayMessage();
    err.DisplayMessage();
    err.DisplayMessage( NULL, NULL, MB_OK, MMB_AppendExeNameInCaption, LANG_ENGLISH );
    err.DisplayMessage( NULL, NULL, MB_OK, MMB_AppendExeNameInCaption, LANG_ITALIAN );
    my_String s;
    err.GetDisplayMessage( s );
    s.Indent( 4, 8, false );
    s.MakeCRLF();
    WriteLn( s );

    WriteLn( _T("\r\nMessage explicitely in English:") );
    err.GetDisplayMessage( s, LANG_ENGLISH );
    s.Indent( 4, 8, false );
    s.MakeCRLF();
    WriteLn( s );

    WriteLn( _T("\r\nMessage explicitely in German:") );
    err.GetDisplayMessage( s, LANG_GERMAN );
    s.Indent( 4, 8, false );
    s.MakeCRLF();
    WriteLn( s );

    WriteLn( _T("\r\nMessage explicitely in Italian:") );
    err.GetDisplayMessage( s, LANG_ITALIAN );
    s.Indent( 4, 8, false );
    s.MakeCRLF();
    WriteLn( s );

    WriteLn( _T("\r\n_retread_t_ rr:") );
    _retread_t_ rr = _retread_t_(interr (errFileNoStream), 10);
    rr.getError().GetDisplayMessage( s );
    s.Replace( _T('\n'), _T(' ') );
    String s2;
    s2.Sprintf( _T("rr error = %s\r\nrr value = %d"), (PCTSTR) s, rr.getValue() );
    WriteLn( s2 );
    s2.Sprintf( _T("rr value == 10 -> %s"), rr == (_size_t_) 10 ? _T("true") : _T("false") );
    WriteLn( s2 );
    s2.Sprintf( _T("rr value != 10 -> %s"), rr != (_size_t_) 10 ? _T("true") : _T("false") );
    WriteLn( s2 );
    s2.Sprintf( _T("11 == rr value -> %s"), (_size_t_) 11 == rr ? _T("true") : _T("false") );
    WriteLn( s2 );
    s2.Sprintf( _T("11 != rr value -> %s"), (_size_t_) 11 != rr ? _T("true") : _T("false") );
    WriteLn( s2 );
    }


    SetStatus( _T("finished.") );
    SetDlgItemText( g_hwndApp, IDC_EDIT1, g_testString );
    UpdateWindow( g_hwndApp );
}



LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    LRESULT lr;

    // handle control grouping messages
    if( g_cg.HandleWndMessage(lr, hwnd, message, wParam, lParam) )
        { SetWindowLong(hwnd, DWL_MSGRESULT, (long) lr); return TRUE; }

    // handle tray icon messages.
    if( g_trayicon.HandleWndMessage(lr, hwnd, message, wParam, lParam) )
        { SetWindowLong(hwnd, DWL_MSGRESULT, (long) lr); return TRUE; }

    switch( message ) 
    {
        case WM_INITDIALOG :
        {
            g_hwndApp = hwnd;

            #ifdef _DEBUG
            SetWindowText( hwnd, String().GetWindowtext( hwnd ) + _T(" <DEBUG>") );
            #endif

            Version v;
            String productname    = v.Get( Tverstr_ProductName );
            String productversion = v.Get( Tverstr_ProductVersion );
            g_trayicon.CreateIcon( hwnd, IDI_SMALL, WM__TRAYICON,
                                   productname + _T(" v") + productversion.BeautifyVersionNr() + _T(" build ") + productversion.GetBuildNr() );
            g_trayicon.SetAutoPopupMenu( IDR_MENU1, 0, IDC_ABOUT );

            HDC hdc = ::GetDC( hwnd );
            int nHeight = -MulDiv( 8, GetDeviceCaps( hdc, LOGPIXELSY ), 72 );
            ::ReleaseDC( hwnd, hdc );
            g_hFont = CreateFont( nHeight, 0, 0, 0, 0, FALSE, FALSE, FALSE,
                                  0, 0, 0, 0, 0, _T("Lucida Console") );

            SendDlgItemMessage( hwnd, IDC_EDIT1, WM_SETFONT, (WPARAM) g_hFont, FALSE );

            MessageBox( hwnd,
                        _T("First, some message boxes with pseudo error informations will be displayed.\n")
                        _T("They demonstrate the ArgonLibrary's error handling feature, displayed in different languages."),
                        _T("Information"),
                        MB_OK );
            DoTest();

            g_cg.setWindowDeferrer( &g_WindowDeferrer );
            // Note: It is not necessary to use a window defferer. But it is much better.
            // Because with it, the controls will be repsotioned at once. And sometimes
            // Windows has problems to redraw controls when their positions change not
            // using a window deferrer (in non layered window mode).
            // This problem also does not occur when using a window deferrer.
            // Note:
            // Don't forget to enable the dialog's CLIPCHILDREN mode to prevent flickering
            // of the controls when they are rearranged.
            // Unfortunately, Edit controls and some few others flicker nevertheless
            // which is a result of their internal implementation.

            // control grouping
            g_cg.ComposeStart();
            g_cg.AddRootGroup( hwnd );
            g_cg.AddGrid( _T(""), _T("outerGrid"), _Size_(1, 2) );
            g_cg.AddGrid( _T("outerGrid-2"), _T("bottomGrid"), _Size_(5, 1) );
            g_cg.AddControlID( _T("outerGrid-1"), _T("Textfield"), hwnd, IDC_EDIT1 );
            g_cg.AddControlID( _T("bottomGrid-1"), _T("Status"), hwnd, IDC_STATUS );
            g_cg.AddSeparatorItem( _T("bottomGrid-2"), _T("Sep2") );
            //g_cg.AddControlID( _T("bottomGrid-3"), _T("OkButton"), hwnd, IDOK );
            //g_cg.AddControlID( _T("bottomGrid-3"), _T("TestButton"), hwnd, IDC_TEST );
            g_cg.AddGrid( _T("bottomGrid-3"), _T("ctrlsGrid"), _Size_(1, 2) );
            g_cg.AddControlID( _T("ctrlsGrid-1"), _T("AlphaCheckbox"), hwnd, IDC_ALPHA );
            g_cg.AddGrid( _T("ctrlsGrid-2"), _T("btnGrid"), _Size_(2, 1) );
            g_cg.AddControlID( _T("btnGrid-1"), _T("OkButton"), hwnd, IDOK );
            g_cg.AddControlID( _T("btnGrid-2"), _T("TestButton"), hwnd, IDC_TEST );
            g_cg.AddSeparatorItem( _T("bottomGrid-4"), _T("Sep4") );
            g_cg.AddControlID( _T("bottomGrid-5"), _T("AboutButton"), hwnd, IDC_ABOUT );
            if( !g_cg.ComposeEnd() )
                MessageBox( hwnd, g_cg.m_strComposeErrors, _T("ControlGrouping Error"), 0 );

            g_cg.SetFixedSize( _T("outerGrid-row2"), false, true );
            g_cg.SetFixedSize( _T("bottomGrid-1"), true, false );
            g_cg.SetFixedSize( _T("bottomGrid-3"), true, false );
            g_cg.SetFixedSize( _T("bottomGrid-5"), true, false );
            g_cg.SetMinWidth( _T("Sep2"), 4 );
            g_cg.SetMinWidth( _T("Sep4"), 4 );

            //g_cg.SetTopOrLeftBorderAutoDragable( _T("outerGrid-row2"), true );
            g_cg.SetTopOrLeftBorderAutoDragable( _T("btnGrid-2"), true );

            /*
            // make layered window for testing
            SetLayeredWindowExstyle( hwnd );
            SetLayeredWindowAttributes( hwnd, 0, 230, LWA_ALPHA );
            */

            // We enable layered window now if possible.
            if( User32Dll::IsLayeredWindowsSupported() )
            {
                // Note: When #SetLayeredWindowAttributes()# is called the first time after
                // setting WS_EX_LAYERED style bit, a flickering can occur because the bitmap
                // Windows is using for the alpha layer will be empty (black) first and that
                // will be visible until WM_PAINT is executed.
                // To prevent this, we make the alpha transparency first almost completely
                // transparent and then show the window. Then WM_PAINT will be executed.
                // When we then again call #SetLayeredWindowAttributes()# to set our
                // desired transparency, the alpha bitmap contains already the dialog
                // content and no flickering will be visible any more.
                SetLayeredWindowExstyle( hwnd );
                SetLayeredWindowAttributes( hwnd, 0, 1, LWA_ALPHA );
                ShowWindow( hwnd, SW_SHOWNORMAL );
                UpdateWindow( hwnd );
                SetLayeredWindowAttributes( hwnd, 0, 220, LWA_ALPHA );
            }

            if( GetWindowLongPtr(hwnd, GWL_EXSTYLE) & WS_EX_LAYERED )
                CheckDlgButton( hwnd, IDC_ALPHA, TRUE );

            EnableWindow( GetDlgItem(hwnd, IDC_ALPHA), User32Dll::IsLayeredWindowsSupported() );

            return TRUE;
        }

        case WM_COMMAND :
        {
            if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
            {
                EndDialog(hwnd, LOWORD(wParam));
                return TRUE;
            }
            switch( LOWORD(wParam) )
            {
                case IDC_ABOUT :
                {
                    //DialogBox( g_hInstance, (LPCTSTR)IDD_ABOUTBOX, hwnd, (DLGPROC)About );
                    AboutBox ab;
                    ab.DoModal( IDI_TESTLIBSOURCES1,
                                _T("This software is freeware. You may copy and redistribute this ")
                                _T("program as long as all copyright notices remain intact.\n\n")
                                _T("The author of this program accepts no responsibility for ")
                                _T("damages that are caused by this program and makes NO ")
                                _T("WARRANTIES or representation, either express or implied, ")
                                _T("with respect to this software. This software is provided ")
                                _T("\"AS IS\", and you, its user, assume the entire risk when ")
                                _T("you use it.") );
                    break;
                }

                case IDC_TEST :
                    g_trayicon.RecreateIcon();  // just for testing purposes
                    DoTest();
                    break;

                case IDC_ALPHA :
                    // We en/disable layered window now if possible.
                    if( IsDlgButtonChecked( hwnd, IDC_ALPHA ) )
                    {
                        SetLayeredWindowExstyle( hwnd );
                        SetLayeredWindowAttributes( hwnd, 0, 220, LWA_ALPHA );
                    }
                    else
                        SetLayeredWindowExstyle( hwnd, FALSE );
                    break;

                case IDC_MMBDLGRES :
                    DialogBox( g_hInstance, (LPCTSTR)mmbIDD_MOREMESSAGEBOX, hwnd, (DLGPROC)ExtraDlgProc );
                    break;

                case IDC_FULLMMB :
                {
                    MoreMessageBox mmb;

                    mmb.m_strOwnBtn1 = _T("Dismiss &Me!");
                    mmb.m_strOwnCheck2 = _T("Clicky clicky ...");

                    mmb.MessageBox( NULL,
                        _T("This is the message text.\nWe make it long to extend the width to the right to see if text is *not* broken."),
                        _T("Here you can put more detailed descriptions.\n")
                        _T("Text in here will not be broken automatically.\n")
                        _T("If you do not pass any Long Message text, the More button will not be displayed."),
                        _T("Full MoreMessageBox Test"),
                        MB_OKCANCEL | MB_ICONEXCLAMATION,
                        MMB_TextLikeMessageBox |
                        MMB_AlignMsgTextTop |
                        MMB_2Checkboxes |
                        MMB_AlignButtonsRight |
                        //MMB_AlignExtraIconBottom |
                        MMB_AppendExeNameInCaption,
                        GetThreadLocale(), //LANG_ENGLISH,
                        _T("Do you really want to read this header ?\nWell this is just a test. So I don't care.   ;)"),
                        _T("Ok. This is an area for additional informations. You can use it as you wish. ")
                        _T("Different than to the normal message text, the width of this Extra message does ")
                        _T("not affect the width of the message box. So the text will just be broken on word boundaries."),
                        _T("Here you can make a link. This test goes to Winamp."),
                        _T("http://www.winamp.com"),
                        Get_Resource_Instance(),
                        IDI_NOTES, IDI_GREENLIGHT );

                    break;
                }

                case IDC_MINIMMB :
                {
                    MoreMessageBox mmb;
                    mmb.MessageBox( _T("Just a minimalistic MoreMessageBox."), NULL, NULL, MB_OK, MMB_TextLikeMessageBox );
                    break;
                }

                case IDC_FILENAMEDIALOG :
                {
                    FilenameDialog d;
                    d.AllowMultiselect();
                    bool ret = d.DoModal();

                    String s;
                    s.Sprintf( _T("%d Files selected.\nDirectory = \"%s\"\nFirst file = \"%s\"\nOpen the Details for a list of filenames.\n\nThe user pressed the %s button."),
                               d.m_cResultFiles, (PCTSTR) d.m_strResultDirectory, (PCTSTR) d.m_strResultFirstFullfilename, ret ? _T("OK") : _T("Cancel") );

                    String s2 = d.m_strResultFiles;
                    s2.Replace( _T('|'), _T('\n') );

                    for( _idx_ i = 0 ; i < d.m_cResultFiles ; ++i )
                        s2 += _T('\n') + d.getResultFullFilenameAt( i );

                    MoreMessageBox mmb;
                    mmb.MessageBox( s, s2, _T("FilenameDialog Results:"), MB_OK, MMB_TextLikeMessageBox );
                    break;
                }

                case IDC_FORCEFGND :
                {
                    #define TIMERID_FGND    124
                    SetTimer( hwnd, TIMERID_FGND, 3000, NULL );
                    break;
                }
            }
            break;
        }

        case WM_TIMER :
        {
            if( wParam == TIMERID_FGND )
            {
                KillTimer( hwnd, TIMERID_FGND );

                //MoreMessageBox mmb;
                //mmb.MessageBox( _T("This MoreMessageBox is forced to be the foreground window."), NULL, NULL, MB_OK | MB_SETFOREGROUND, MMB_TextLikeMessageBox );

                MoreMessageBox::PushForegroundWindow( hwnd );
            }

            break;
        }
    }

    return FALSE;
}

LRESULT CALLBACK ExtraDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            return TRUE;

        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }

            switch( LOWORD(wParam) )
            {
                case mmbIDC_EXTRALINK :
                {
                    if( HIWORD(wParam) == STN_CLICKED )
                        Beep( 1000, 100 );
                    break;
                }
            }

            break;
    }

    return FALSE;
}
